<?php
/**
 * Created by PhpStorm.
 * User: tuliomagalhaes
 * Date: 30/06/14
 * Time: 14:42
 */

namespace Controller;

use Util\Utilities;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource;

class AccessProfileControl {
    /**
     * @var \Util\Utilities
     */
    private $environment;
    /**
     * @var \Service\AccessProfileControl
     */
    private $accessProfileControlService;

    /**
     * @param \Service\AccessProfileControl $accessProfileControlService
     * @param Utilities $environment
     */
    public function __construct(\Service\AccessProfileControl $accessProfileControlService, Utilities $environment) {
        $this->environment = $environment;
        $this->accessProfileControlService = $accessProfileControlService;
    }

    /**
     * @param Request\Filter $request
     * @param Response $response
     */
    public function findProfilesByOrganization(Request\Filter $request, Response $response){
        try {
            $dataSet = $this->accessProfileControlService->findProfilesByOrganization($this->environment->getCurrentOrganizationId());
            $response->addDataSet(new DataSet('profile', $dataSet));
        } catch (\Exception $e){
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_WARNING));
        }
    }

    /**
     * @param Request\DataSet $request
     * @param Response $response
     */
    public function saveAccessProfileControl(Request\DataSet $request, Response $response) {
        try{
            $rows = $request->getDataSet()->getRows();
            $this->accessProfileControlService->saveAccessProfileControl($rows[0]['CONTROL'], $rows[0]['PROFILE'], $this->environment->getCurrentOrganizationId());
        } catch(\Exception $ex){
            $response->addMessage(new Response\Message($ex->getMessage(), Response\Message::TYPE_ERROR));
        }
    }

    /**
     * @param Request\Filter $request
     * @param Response $response
     */
    public function findPerfilAcesso(Request\Filter $request, Response $response) {
        try{
            $accessProfile = $this->accessProfileControlService->findPerfilAcesso();
            $response->addDataSet(new DataSet('perfilAcesso', $accessProfile));
        } catch(\Exception $ex){
            $response->addMessage(new Response\Message($ex->getMessage(), Response\Message::TYPE_ERROR));
        }
    }



} 