<?php
namespace Service;

use Doctrine\ORM\EntityManager;
use Util\InstanceProvider;
use Zeedhi\DevOps\Util\Utilities AS DevOpsUtilities;

class Label
{
    /**
     * @var EntityManager
     */
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function findLabelByBoardIssueFilter($conditions, $page, $pageSize)
    {
        $environment = InstanceProvider::getEnvironment();
        $organization = $environment->getCurrentOrganizationId();
        $userId = $environment->getCurrentUserId();

        $limit = $page * $pageSize;
        $offset = ($page - 1) * $pageSize;
        $filters = DevOpsUtilities::createQueryFiltered($conditions);
        $products = InstanceProvider::getRepository()->getProject()->findMyProducts($organization, 0, $userId, '');
        $projectIds = InstanceProvider::getService()->getIssue()->getImInMeetingProjectIds();

        foreach($products as $product){
            $projectIds[] = $product['ID'];
        }


        return InstanceProvider::getRepository()->getTask()->findLabelByBoardIssue($projectIds, $organization, $userId, $filters, $limit, $offset);
    }

}