/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_ESPECANIMAL                                              */
/* Tabela : ESPECANIMAL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/* 03/12/2004 - JOAO PAULO REIS                                               */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_ESPECANIMAL
BEFORE INSERT OR UPDATE OR DELETE
ON ESPECANIMAL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUESAN := SYSDATE;
   END IF;
   IF UPDATING THEN
      if (NVL(:OLD.CDESPEANIMAL,0) <> NVL(:NEW.CDESPEANIMAL,0))  OR
         (NVL(:OLD.NMESPEANIMAL,0) <> NVL(:NEW.NMESPEANIMAL,0)) THEN
         :NEW.DTULTATUESAN:= SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('ESPECANIMAL', '', 'CDESPEANIMAL='||:OLD.CDESPEANIMAL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE ESPECANIMAL MODIFY DTULTATUESAN DEFAULT SYSDATE
/

